/*
 * mle.h -- MLE interface to the outside world
 *
 * Created by Microsoft Corporation, 1989
 */

/********* New messages and constants. ************/

#define EM_SETWRAP		(WM_USER+1)
#define EM_QTL			(WM_USER+2)
#define EM_LINEFROMCHAR		(WM_USER+3)
#define EM_CHARFROMLINE		(WM_USER+4)
#define EM_SETFONT		(WM_USER+5)
#define EM_QUERYFONT		(WM_USER+6)
#define EM_SETCHANGED		(WM_USER+7)
#define EM_QUERYTYPING		(WM_USER+8)
#define EM_SETTYPING		(WM_USER+9)
#define EM_FORMAT		(WM_USER+10)
#define EM_SETTABSIZE		(WM_USER+11)
#define EM_QUERYTABSIZE		(WM_USER+12)

#define EM_SETIMPORTEXPORT	(WM_USER+20)
#define EM_IMPORT		(WM_USER+21)
#define EM_EXPORT		(WM_USER+22)
#define EM_REPLACE		(WM_USER+23)
#define EM_DELETE		(WM_USER+24)
#define EM_GETTEXT		(WM_USER+25)

#define EN_HSCROLL		EN_SCROLL
#define EN_VSCROLL		0x0020


#define SLIDER_MIN 0             // range of valid scroll bar positions.
                                 // This shouldn't be too wide, since for very
                                 // long documents it could cause an overflow
                                 // when calculating the position of the
                                 // vertical slider.
#define SLIDER_MAX 200

// buffer import/export formats
#define MLE_CFTEXT 0
#define MLE_CSTD 1
#define MLE_WINFMT 2

/********* Types needed for certain messages. ***********/

// WARNING:  These must match definitions in mtypes.h.

typedef LONG IPT;       // insertion point in text (between two chars)
typedef SHORT LINE;     // line number
#define MLE		// We've made the definitions...


/* External variables provided by MLE routines. */

extern PSZ cdecl WC_MLE;


/* Calls to MLE routines. */

BOOL EXPENTRY MleInit (HAB hab);     // initialize the MLE by registering
                                     // the MLE class
