#include "mle.h"

/****** Resource IDs *****/

#define IDR_NP    255
#define IDR_PREV  263

/****** Menu command IDs *****/
/* (by convention, hi byte is menu index, lo byte is dispatch table index) */

/* File menu */

#define SUB_FILE    0x0000
#define CMD_NEW     0x0000
#define CMD_OPEN    0x0001
#define CMD_SAVE    0x0002
#define CMD_SAVEAS  0x0003
#define CMD_PRINT   0x0009
#define CMD_ABOUT   0x000a
#define CMD_EXIT    0x0010

/* Edit menu */
#define SUB_EDIT    0x0100
#define CMD_UNDO    0x0104
#define CMD_CUT     0x0105
#define CMD_COPY    0x0106
#define CMD_PASTE   0x0107
#define CMD_CLEAR   0x0108
#define CMD_SELECTALL 0x010b
#define CMD_DATETIME 0x0111

/* Search menu */
#define SUB_SEARCH  0x0200
#define CMD_FIND    0x020c
#define CMD_REPLACE 0x020d
#define CMD_NEXTSRCH 0x020e

/* Options menu */
#define SUB_OPTIONS    0x0300
#define CMD_WRAPTOGGLE 0x030f
/*
#define CMD_FIXEDFONT  0x0312    -- now unused
*/
#define CMD_SETTAB     0x0313

#define CMD_QUERYFONT  0x0314

#define SUB_FONTS 0x0400
#define SUB_SIZES 0x0500
#define SUB_HELP  0x0600
/* Number of menu commands */
#define CCMDS       (7+7+3+4)

/********************* Message Strings *********************/

/*  Message string id's */
#define MS_STRNOTFOU 1
#define MS_UNTITLED  2
#define MS_DOC       3
#define MS_OPENFILE  4
#define MS_DFLEXT    5
#define MS_SAVEAS    6
#define MS_APPNAME   7
#define MS_SAVEERR    8
#define MS_LOADERR    9

/*  Number of message strings */
#define MS_COUNT 9
#define MS_MAXMSGSIZE 70

/*  Search Key information */
#define NP_KEYSIZE 80

#define MAXFILENAMESZ 255
#define NP_TITLESIZE MS_MAXMSGSIZE
#define NP_PROFILESIZE NP_KEYSIZE

/*  ID for edit window within client area */
#define NP_EDITWINDOWID 1

#ifndef RC_INVOKED

/******************** KMP Search info */

typedef int STATE;

typedef struct _COMPILEDKEY {
        char key[NP_KEYSIZE+2];
        STATE fail[NP_KEYSIZE+2];
        STATE final;
} COMPILEDKEY;
typedef COMPILEDKEY *PCOMPILEDKEY;

/************* GLOBAL VARIABLES         */

extern HAB  hab;
extern HWND hwndNP;
extern HWND hwndNPFrame;
extern HWND hwndNPMenu;
extern HWND hwndNPEdit;

extern char *szClientMsg;

extern BOOL fWordWrapOn;
extern char szFileName[];
extern char szLoadFileName[];
extern BOOL fInitLoad;
extern BOOL fInitError;
extern char szTitle[];
extern BOOL fNamed;
extern BOOL fChanged;

extern PCOMPILEDKEY pckSearchKey;
extern BOOL fKeySet;

extern char szMsgs[MS_COUNT+1][MS_MAXMSGSIZE];

extern HHEAP hhAppHeap;

#endif

#define EDM_INIT  WM_USER+0

/********************* Previewer Window Stuff *********************/

#define PCMD_REFRESH     0x0000
#define PCMD_FORWARD     0x0001
#define PCMD_START       0x0002

/* Number of menu commands */
#define CPCMDS       (3)

