/* npcmd.h -- command processing  */

VOID CmdNew(VOID);
VOID CmdOpen(VOID);
VOID CmdSave(VOID);
VOID CmdSaveAs(VOID);
VOID CmdPrint(VOID);
VOID CmdExit(VOID);
VOID CmdAbout(VOID);
VOID CmdUndo(VOID);
VOID CmdCut(VOID);
VOID CmdCopy(VOID);
VOID CmdPaste(VOID);
VOID CmdClear(VOID);
VOID CmdSelectAll(VOID);
VOID CmdDateTime(VOID);
VOID CmdFind(VOID);
VOID CmdReplace(VOID);
VOID CmdNextSearch(VOID);
VOID CmdWordWrap(VOID);
VOID CmdSetTab(VOID);
VOID CmdQueryFont(VOID);

/*  Initialization */
BOOL InitSrch(VOID);
VOID CmdParseLine(int argc, char **argv);
VOID CmdCmdLine(VOID);

/*  Assistance for command processing */
VOID SetWordWrap(BOOL);

/*  Dialog box procedures */
MRESULT CALLBACK SearchDlgProc(HWND, USHORT, MPARAM, MPARAM);
MRESULT CALLBACK ReplaceDlgProc(HWND, USHORT, MPARAM, MPARAM);
MRESULT CALLBACK TabDlgProc(HWND, USHORT, MPARAM, MPARAM);

/*  File manipulation */
VOID NPClear(VOID);
int NPCheckSave(VOID);
BOOL NPOpenRead(VOID);
VOID NPSave(VOID);
VOID NPSaveAs(VOID);
BOOL NPLoadNamedFile(PSZ fn);

BOOL fIsChanged(VOID);
VOID SetChanged(VOID);
VOID ClearChanged(VOID);
VOID SetTitle(PSZ);

/* Date/Time manipulation */
PSZ fmtDateTime(PSZ);

/* Search/replace */
BOOL DoSearch(VOID);
BOOL DoReplace(VOID);
VOID DoSetKey(VOID);
BOOL DoNextSearchRep(VOID);

/* Linear access to edit control text */
VOID LFAInit(BOOL fAtStart);
CHAR LFANextCh(VOID);
ULONG LFAStartPos(VOID);

/* Font manipulation */
VOID SelectFont(SHORT sFontIndex);
VOID InitFonts(VOID);
BOOL SelectSizeIndex(SHORT sIndex);
PSZ CurrFaceName(VOID);
SHORT CurrFaceSize(VOID);


/* printing */
BOOL NPPrint(VOID);
