/***************************************************************************\
* nptab.c - handle changing tab size
*
* Created by Microsoft Corporation, 1989
*
\***************************************************************************/

#define INCL_WIN
#include <os2.h>
#include "notepad.h"
#include "npabout.h"
#include "npcmd.h"

/********** Tab Dialog Window Procedure **************/

MRESULT CALLBACK TabDlgProc(hwnd, msg, mp1, mp2)
HWND hwnd;
USHORT msg;
MPARAM mp1;
MPARAM mp2;
{
    USHORT usTabSize;

    switch (msg) {

    case WM_INITDLG:
        usTabSize = (USHORT)(WinSendMsg(hwndNPEdit, EM_QUERYTABSIZE, 0L, 0L));
        WinSetDlgItemShort(hwnd,
                NP_TABSIZE,
                usTabSize,
                FALSE);
        return(0L);
        break;

    case WM_COMMAND:
        switch (LOUSHORT(mp1)) {
        case NP_TAB_SET:
            WinQueryDlgItemShort(hwnd, NP_TABSIZE, (PSHORT)&usTabSize, FALSE);
            WinSendMsg(hwndNPEdit,
                    EM_SETTABSIZE,
                    MPFROMLONG((ULONG)usTabSize),
                    0L);
            WinDismissDlg(hwnd,MBID_OK);
            return(0L);
            break;

        case NP_TAB_CANCEL:
            WinDismissDlg(hwnd,MBID_CANCEL);
            return(0L);
            break;

        default:
            return(0L);
            break;
        }
        break;

    case WM_HELP:
        return(0L);
        break;

    default:
        return(WinDefDlgProc(hwnd, msg, mp1, mp2));
        break;
    }
}

